#define STRICT
#include <windows.h>
#pragma hdrstop

#include "rc.h"
#include "usb_connect.h"

const char* ProgName = "Coolpix RAW Enabler";
DSC* dsc;
HINSTANCE hAppInst;
HWND hAppWin;

bool raw_enabled = false;
bool changed = false;

void InitDlg(HWND hDlg)
{
   TInquiryData inquiry;

   if( GetDeviceName(dsc->GetHandle(), inquiry) )
   {
      char buff[80];
      wsprintf(buff, "%8.8s%16.16s%4.4s",
         inquiry.VendorId,
         inquiry.ProductId,
         inquiry.ProductRevisionLevel);

      SetDlgItemText(hDlg, IDC_PRODUCT_INFO, buff);
   }



   TResponce responce;

   if( dsc->GetVar(0x16, responce) )
   {
      raw_enabled = false;
      if( strstr(responce.GetStr(), "DIAG") != 0 && strstr(responce.GetStr(), "RAW") != 0 )
         raw_enabled = true;

      EnableWindow( GetDlgItem(hDlg, IDC_RAW_ENABLED), TRUE );
      CheckDlgButton(hDlg, IDC_RAW_ENABLED, raw_enabled ? BST_CHECKED:BST_UNCHECKED);
   }
   else
   {
      EnableWindow( GetDlgItem(hDlg, IDC_RAW_ENABLED), FALSE );
   }
}

bool Update()
{
   return dsc->SetStr(0x16, raw_enabled ? "DIAG RAW" : "NIKON DIGITAL CAMERA" );
}

BOOL Command(HWND hDlg, int NotifyCode, int id, HWND hCtrl)
{
   NotifyCode;
   hCtrl;

   switch(id)
   {
   case IDCANCEL:
      PostMessage(hDlg, WM_CLOSE, 0,0);
      return TRUE;

   case IDOK:
      // Update
      if( changed )
      {
         if( Update() )
            MessageBox(hDlg, raw_enabled ?
               "RAW mode enabled":"RAW mode disabled", ProgName, MB_ICONINFORMATION|MB_OK);
         else
            MessageBox(hDlg, "Cannot change RAW mode", ProgName, MB_ICONSTOP|MB_OK);
      }
      PostMessage(hDlg, WM_CLOSE, 0,0);
      return TRUE;

   case IDC_RAW_ENABLED:
      changed = true;
      raw_enabled = ! raw_enabled;

      CheckDlgButton(hDlg, IDC_RAW_ENABLED, raw_enabled ? BST_CHECKED:BST_UNCHECKED);
      return TRUE;

   default:
      return FALSE;
   }
}

BOOL CALLBACK MainDlg( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   if( uMsg == WM_INITDIALOG )
   {
      if( !hAppWin )
         hAppWin = hDlg;

      InitDlg(hDlg);
      return TRUE;
   }

   if( uMsg == WM_COMMAND )
   {
      return Command(hDlg, HIWORD(wParam), LOWORD(wParam), (HWND) lParam);
   }
   if( uMsg == WM_CLOSE )
   {
      if( hDlg == hAppWin )
         hAppWin = NULL;
         
      EndDialog(hDlg, 0);
      return FALSE;
   }
   return FALSE;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPSTR, int )
{
   hAppInst = hInstance;

   DSC Camera = OpenDSC();
   if( !Camera.Okay() )
   {
      while(1)
      {
         if( IDYES != MessageBox(NULL, "Can not connect to camera\r\nTry again?", ProgName, MB_YESNO ) )
            return 0;

         Camera = OpenDSC();
         if( Camera.Okay() )
            break;
      }
   }
   dsc = &Camera;
   DialogBox( hAppInst, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlg);
   dsc = NULL;
   return 0;
}
